// Complete testing of double linked list class

#include <iostream.h>
#include "tdllist.h"


// Iteration function for the B template
inline void dprint (const double &d, void *extra)
   {
   cout << d << ",";
   }

// Function for testing first_that
inline int more_than_5 (const double &a, void *extra)
   {
   if(a>5) return 1;
   else return 0;
   }
// Function for testing last_that and showing how to pass arguments
inline int less_than (const double &a, void *extra)
   {
   double arg = *((double*)extra);

   if(a<arg) return 1;
   else return 0;
   }

int main (void)
   {
   cout << "\n\nVerifying Tdouble_link_list class operation...\n";

   int i, num;

   // The list to test
   Tdouble_link_list<double> a;

   // Making sure we start with an empty number
   cout << "Verifying initial number\n";

   num = a.number();
   if(num==0) cout << "Initial number verified\n";
   else cout << "Failure in initial number check!\n";

   // Checking the appending stuff
   cout << "Doing 10 appends to the vector\n";

   for(i=0;i<10;i++)
      {
      a.append(i);
      }

   // Making sure we have the correct size now
   cout << "Verifying number after 10 appends\n";

   num = a.number();
   if(num==10) cout << "Appending number verified\n";
   else cout << "Failure in appending number check!\n";

   // Lets try printing everything out with the for_each
   cout << "Verifying for_each by printing, you should see number 0 to 9\n";

   a.for_each(dprint,NULL);
   cout << endl;

   // Lets try removing the last element
   cout << "Lets remove the last element and print again\n";

   a.remove();
   a.for_each(dprint,NULL);
   cout << endl;

   // Lets look at some elements with operator[]
   cout << "Lets look at some elements with operator[]\n";

   cout << "a[1] is " << a[1] << endl;

   // Lets modify some elements with operator[]
   cout << "Lets modify some elements with operator[]\n";
   cout << "Setting a[1] to -1.0" << endl;

   a[1] = -1.0;
   cout << "a[1] is now " << a[1] << endl;

   // Lets look at the first and last elenemts
   cout << "Lets look at the first and last elenemts\n";
   cout << "first is " << a.first() << endl;
   cout << "last is " << a.last() << endl;

   // Lets try removing the secont to last element
   cout << "Lets remove the second to last element and print again\n";

   a.remove(a.prev(a.last()));
   a.for_each(dprint,NULL);
   cout << endl;

   // Lets prepend a -1 to the list
   cout << "Lets prepend a -1.0 to the list and print again\n";

   a.prepend(-1.0);
   a.for_each(dprint,NULL);
   cout << endl;

   // Lets put the second last element back again
   cout << "Lets put the second last element back again\n";

   a.append(7.0,a.prev(a.last()));
   a.for_each(dprint,NULL);
   cout << endl;

   // Lets find the first object greater than 5
   cout << "Lets find the first object greater than 5\n";
   cout << "using a simple function with no arguments\n";

   double *gtfive = a.first_that(more_than_5,NULL);

   if(gtfive!=NULL) cout << "First element < 5 is " << *gtfive << endl;
   else cout << "Failure to find first element!\n";

   // Lets find the last object greater than 4
   cout << "Lets find the last object less than 4\n";
   cout << "using a simple function passing the 4 as an argument\n";

   double comparison = 4.0;
   double *ltfour = a.last_that(less_than,&comparison);

   if(ltfour!=NULL) cout << "Last element < 4 is " << *ltfour << endl;
   else cout << "Failure to last first element!\n";

   // Testing the clear
   cout << "Verifying the clear\n";
   a.clear();

   num = a.number();
   if(num==0) cout << "Clear number verified\n";
   else cout << "Failure of clear!\n";
   }


