//----------------------------------------------------------------------------
//
// DETL - A template library 1.0 beta
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Base class for guaranteed object delete at program exit
//----------------------------------------------------------------------------
#ifndef GUARANTEED_DELETE_HEADER
#define GUARANTEED_DELETE_HEADER
//----------------------------------------------------------------------------
class guaranteed_delete
   {
   private:
      // The list of created objects
      static bool initialized;
      static guaranteed_delete** objects;
      static int number;

   protected:
      // Constructor and destructor are private so that
      // only derived classes can use them
      guaranteed_delete (void);
      virtual ~guaranteed_delete (void);

   public:
      // Start remembering all the objects created so we
      // can delete them on program exit
      static void init (void) { initialized = true; };

   friend void exit_cleanup (void);
   };
//----------------------------------------------------------------------------
#endif

