//----------------------------------------------------------------------------
//
// DETL - A template library 1.0 beta
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Implementation of program argument list
//------------------------------------------------------------------------------
#include "argument.h"
#include <string.h>
//------------------------------------------------------------------------------
// Globally visible program arguments
arguments program_arguments;

//------------------------------------------------------------------------------
// Find out if an argument name is contained in the group
int arguments::contains (const char *nam)
	{
   for(int i=0;i<argc;i++)
      {
      if(stricmp(nam,argv[i])==0) return i;
      }
   return 0;
	}
//------------------------------------------------------------------------------
// Find out if an argument name is contained in the group
bool arguments::contains (const char *header, const char *nam)
	{
   // First search for the header
   int i;
   for(i=0;i<argc;i++)
      {
      if(stricmp(header,argv[i])==0) break;
      }
   // If we don't have the header then we don't have anything
   if(i>=argc) return false;

   // Now check the next argument if there is onr
   if((i<(argc-1))&&(stricmp(nam,argv[i+1])==0)) return true;

   return false;
	}
//------------------------------------------------------------------------------
// Give a pointer to an argument
const char *arguments::get (const char *header)
	{
   // First search for the header
   int i;
   for(i=0;i<argc;i++)
      {
      if(stricmp(header,argv[i])==0) break;
      }
   // Now check the next argument if there is one
   if(i<(argc-1)) return argv[i+1];

   // If we don't have the header then we don't have anything
   return NULL;
	}
//------------------------------------------------------------------------------
// Globally visible program name
const char* arguments::program_name (void)
   {
   return argv[0];
   }
//------------------------------------------------------------------------------

